#include <afxwin.h>
#include <math.h>
#include <afxdlgs.h>
#include "Resource.h"

//#define DEBUG

#define DRAG	32
#define PREC	0x800
//These are PREC values
#define FRICTION 0x2000
#define LIMIT	0x80000
#define FORCE	0x800

#define SPRITES 9
#define SIZE	24
#define CARS	32
#define MASKCOL RGB(0,255,255)
#define BACKX	32
#define BACKY	32*6
#define LEVELX	32
#define LEVELY	24

//******************************************************************************************
bool kanticlock=false;
bool kclock=false;
bool kaccel=false;
bool kbreak=false;
int x=120,y=120;
bool bpaint=false;

BOOL fturn=TRUE;
int gLIMIT=LIMIT;
BOOL bLIMIT=TRUE;
int gFRICTION=FRICTION;
int gDRAG=DRAG;
int gFORCE=FORCE;

//******************************************************************************************

class CMyApp : public CWinApp
{
public:
	virtual BOOL InitInstance();
};

class CMainWindow : public CFrameWnd
{
public:
	CMainWindow();
protected:
	afx_msg int OnCreate(LPCREATESTRUCT);
	afx_msg void OnPaint();
//	afx_msg void OnTimer(UINT);
	afx_msg void OnKeyUp(UINT,UINT,UINT);
	afx_msg void OnKeyDown(UINT,UINT,UINT);
	afx_msg void OnClose();
	afx_msg void OnFileExit();
	void SaveBitmap(CBitmap&);	
	void CopyBitmap(CBitmap&);
	afx_msg void OnSaveCars();
	afx_msg void OnSaveTiles();
	afx_msg void OnCopyCars();
	afx_msg void OnCopyTiles();
	afx_msg void OnSaveLevel();
	afx_msg void OnSetupModel();
	void pause();
	DECLARE_MESSAGE_MAP()
private:
	CWinThread* pThread;
	bool bpause;
};
UINT move(LPVOID lp);
class sine
{
public:
	sine();
	int sin(int);
	int cos(int);
	~sine();
private:
	int* table;
};

class CSettingsDialog : public CDialog
{
public:
	int m_nDrag;
	float m_nFriction, m_nSpeed, m_nForce;
	BOOL m_bSpeed,m_bFastTurn,m_bEnabled;
	CSettingsDialog(CWnd* pParentWnd=NULL) : CDialog (IDD_SDIALOG, pParentWnd) {}
protected:
	virtual void DoDataExchange (CDataExchange*);
	afx_msg void OnDefaults();
	afx_msg void OnEnableSpeed();
	DECLARE_MESSAGE_MAP()
};
BOOL WriteDIB(LPSTR szFile, HANDLE hDIB);
HANDLE DDBToDIB( CBitmap& bitmap, DWORD dwCompression, CPalette* pPal);
//******************************************************************************************

sine::sine()
{
	table=new int [CARS+CARS/4];
    for(int a=0;a<CARS+CARS/4;a++)
		table[a]=int(::sin((a*2*3.14159265359)/CARS)*(PREC-1));
}
         
sine::~sine()
{
	delete [] table;
}

int sine::sin(int angle)
{
	return table[angle];
}

int sine::cos(int angle)
{
	return table[angle+CARS/4];
}

//******************************************************************************************
CMyApp myApp;
CBitmap Mbitmap;
CBitmap Bbitmap;
//CBitmap BackStore;
CBitmap bBuff;

BYTE* level;
//******************************************************************************************
BEGIN_MESSAGE_MAP(CMainWindow, CFrameWnd)
	ON_WM_CREATE()
	ON_WM_CLOSE()
	ON_WM_PAINT()
//	ON_WM_TIMER()
	ON_WM_KEYUP()
	ON_WM_KEYDOWN()
	ON_COMMAND(ID_FILE_EXIT,OnFileExit)
	ON_COMMAND(ID_SAVECARS,OnSaveCars)
	ON_COMMAND(ID_COPYCARS,OnCopyCars)
	ON_COMMAND(ID_SAVETILES,OnSaveTiles)
	ON_COMMAND(ID_COPYTILES,OnCopyTiles)
	ON_COMMAND(ID_LEVEL_SAVEASCARRAY,OnSaveLevel)
	ON_COMMAND(ID_SETUP_MODEL,OnSetupModel)
END_MESSAGE_MAP()

//******************************************************************************************
sine sines;

CMainWindow::CMainWindow()
:bpause(false)
{
	Create(NULL,"Micro",WS_OVERLAPPEDWINDOW,CRect(CW_USEDEFAULT,CW_USEDEFAULT,640+18,240+29),NULL,MAKEINTRESOURCE(IDR_MENU),CS_BYTEALIGNCLIENT);

}
void CMainWindow::OnFileExit()
{
	SendMessage(WM_CLOSE,0,0);
}

void CMainWindow::SaveBitmap(CBitmap& bitmap)
{
	pause();
	char buf[255]="*.bmp";
	CFileDialog dial(false);
	dial.m_ofn.nMaxFile=255;
	dial.m_ofn.lpstrFile=buf;
	dial.DoModal();

	if(buf[0]){
		CPalette pal;
		pal.CreateHalftonePalette (GetDC());
		WriteDIB(buf,DDBToDIB(bitmap,BI_RGB,0));
	}
	pause();
}

void CMainWindow::CopyBitmap(CBitmap& bitmap)
{
	OpenClipboard();
	EmptyClipboard();
	SetClipboardData(CF_DIB,DDBToDIB(bitmap,BI_RGB,0));
	CloseClipboard();
}

void CMainWindow::OnSaveCars()
{
	SaveBitmap(Mbitmap);
}

void CMainWindow::OnSaveTiles()
{
	SaveBitmap(Bbitmap);
}

void CMainWindow::OnCopyCars()
{
	CopyBitmap(Mbitmap);
}

void CMainWindow::OnCopyTiles()
{
	CopyBitmap(Bbitmap);
}

void CMainWindow::OnSetupModel()
{
	pause();
	CSettingsDialog dlg(this);
	dlg.m_bFastTurn=fturn;
	dlg.m_bSpeed=bLIMIT;
	dlg.m_nDrag=gDRAG;
	dlg.m_nFriction=float(gFRICTION)/PREC;
	dlg.m_nSpeed=float(gLIMIT)/PREC;
	dlg.m_nForce=float(gFORCE)/PREC;
	if(dlg.DoModal()==IDOK) {
		fturn=dlg.m_bFastTurn;
		gDRAG=dlg.m_nDrag;
		gFRICTION=int(PREC*dlg.m_nFriction);
		gFORCE=int(PREC*dlg.m_nForce);
		bLIMIT=dlg.m_bSpeed;
		gLIMIT=int(PREC*dlg.m_nSpeed);
	}
	pause();
}

void CMainWindow::OnSaveLevel()
{
	char buf[255]="*.cpp";
	CFileDialog dial(false);
	dial.m_ofn.nMaxFile=255;
	dial.m_ofn.lpstrFile=buf;
	pause();
	dial.DoModal();
	pause();

	CFile file;
	CString string;

	if(file.Open(buf,CFile::modeWrite|CFile::modeCreate) && buf[0])
	{

		string.Format("int level[%d][%d] = {\n",LEVELY,LEVELX);
		file.Write(string,string.GetLength());

		for(int i,j=0;j<LEVELY;j++) {
			if(j==0) string.Format("\t{");
			else string.Format("},\n\t{");
			file.Write(string,string.GetLength());

			for(i=0;i<LEVELX;i++) {
				if(i==0) string.Format("%d",level[i+j*LEVELX]);
				else string.Format(",%d",level[i+j*LEVELX]);
				file.Write(string,string.GetLength());
			}
		}
		string.Format("}\n};");
		file.Write(string,string.GetLength());
	}
}

int CMainWindow::OnCreate(LPCREATESTRUCT lpcs)
{
	if(CFrameWnd::OnCreate(lpcs)==-1) return -1;
	
	CDC* dc=GetDC();

	BYTE* c_ptr;
	DWORD c_len;

	//Make all car bitmaps from IDR_CARS
	HINSTANCE hApp = ::GetModuleHandle(0);
	HRSRC hResInfo = ::FindResource(hApp, MAKEINTRESOURCE(IDR_CARS), RT_RCDATA);
	HGLOBAL hRes = ::LoadResource(hApp, hResInfo);
	c_ptr = (BYTE*) ::LockResource(hRes);
	c_len = ::SizeofResource(hApp, hResInfo);

	Mbitmap.CreateCompatibleBitmap(dc,SIZE,SIZE*CARS);
	//BackStore.CreateCompatibleBitmap(dc,SIZE,SIZE);

	CDC bDC;
	bDC.CreateCompatibleDC (dc);
	bDC.SelectObject (&Mbitmap);

	CPoint pt1,pt2,pt3,pt4;
	int byte=0,bit=8,c;
	int yrel=24;

	int mask;
	int plane1,plane2;

	for(pt1.y=0,pt2.y=SIZE*(SPRITES*2-1)-1,pt3.y=SIZE*(SPRITES*2-1)-1,pt4.y=SIZE*(SPRITES*4-4);
		pt1.y<SIZE*SPRITES;
		pt1.y++,pt2.y--,pt3.y--,pt4.y++
	)
	{
		for(pt1.x=pt2.x=0,pt3.x=pt4.x=SIZE-1;
			pt1.x<SIZE;
			pt1.x++,pt2.x++,pt3.x--,pt4.x--
		)
		{
			if(bit==8)
			{
				bit=0;
				mask=c_ptr[byte];
				plane1=c_ptr[byte+3];
				plane2=c_ptr[byte+6];
				byte++;
			}
			c=(3-((plane1>>7)<<1|plane2>>7))*85;
			if(mask&0x80)
			{
				bDC.SetPixel(pt1,RGB(0,c,0));
				bDC.SetPixel(pt2,RGB(0,c,0));
				bDC.SetPixel(pt3,RGB(0,c,0));
				bDC.SetPixel(pt4,RGB(0,c,0));
			} else {
				bDC.SetPixel (pt1,MASKCOL);
				bDC.SetPixel (pt2,MASKCOL);
				bDC.SetPixel (pt3,MASKCOL);
				bDC.SetPixel (pt4,MASKCOL);
			}

			mask=(mask<<1)&0xFF;
			plane1=(plane1<<1)&0xFF;
			plane2=(plane2<<1)&0xFF;
			bit++;
		}
		byte+=6;
		yrel--;
		if(yrel==0)
		{
			yrel=SIZE;
			pt3.y+=2*SIZE;
			pt4.y-=2*SIZE;
		}
	}

	//Make tile bitmaps (simpler than that for cars)
	hResInfo = ::FindResource(hApp, MAKEINTRESOURCE(IDR_TILES), RT_RCDATA);
	hRes = ::LoadResource(hApp, hResInfo);
	c_ptr = (BYTE*) ::LockResource(hRes);
	c_len = ::SizeofResource(hApp, hResInfo);
	Bbitmap.CreateCompatibleBitmap(dc,BACKX,BACKY);
	bDC.SelectObject (&Bbitmap);

	byte=0; bit=8;
	for(pt1.y=0;pt1.y<BACKY;pt1.y++)
	{
		for(pt1.x=0;pt1.x<BACKX;pt1.x++)
		{
			if(bit==8)
			{
				bit=0;
				plane1=c_ptr[byte];
				plane2=c_ptr[byte+4];
				byte++;
			}
			c=(3-((plane1>>7)<<1|plane2>>7))*85;
			bDC.SetPixel(pt1,RGB(128,c,c));
			plane1=(plane1<<1)&0xFF;
			plane2=(plane2<<1)&0xFF;
			bit++;
		}
		byte+=4;
	}

	//Get level array for tile types
	hResInfo = ::FindResource(hApp, MAKEINTRESOURCE(IDR_LEVEL), RT_RCDATA);
	hRes = ::LoadResource(hApp, hResInfo);
	level = (BYTE*) ::LockResource(hRes);

	//Draw Level into buffer
	CDC buffDC;
	buffDC.CreateCompatibleDC (dc);
	bBuff.CreateCompatibleBitmap(dc,BACKX*LEVELX,BACKX*LEVELY);
	buffDC.SelectObject (&bBuff);
	for(int ix,iy=0;iy<LEVELY;iy++)
		for(ix=0;ix<LEVELX;ix++)
			buffDC.BitBlt(ix*32,iy*32,32,32,&bDC,0,level[iy*LEVELX+ix]*32,SRCCOPY);

	pThread=AfxBeginThread(&move,this);
	pThread->ResumeThread();
	return 0;
}


BOOL CMyApp::InitInstance()
{
	m_pMainWnd=new CMainWindow;
	m_pMainWnd->ShowWindow(m_nCmdShow);
	m_pMainWnd->UpdateWindow();

	return TRUE;

}

void restoreBackground(CDC* dc, int x, int y)
{
//	CDC bDC;
//	bDC.CreateCompatibleDC (dc);
//	bDC.SelectObject (&BackStore);

//	dc->BitBlt(x,y,SIZE,SIZE,&bDC,0,0,SRCCOPY);

}

void draw(CDC* dc,int width, int height,int x, int y,int angle)
{
	CDC bDC,buffDC;
	bDC.CreateCompatibleDC (dc);
	bDC.SelectObject (&Mbitmap);
	bDC.SetBkColor(MASKCOL);

	int wx,wy;
	wx=x+SIZE/2-width/2;
	wy=y+SIZE/2-height/2;
	if(wx>BACKX*LEVELX-width) wx=BACKX*LEVELX-width;
	if(wy>BACKX*LEVELY-height) wy=BACKX*LEVELY-height;
	if(wx<0) wx=0;
	if(wy<0) wy=0;

	buffDC.CreateCompatibleDC (dc);
	buffDC.SelectObject(&bBuff);
	//buffDC.SetBkColor(MASKCOL);

//	bDC.SelectObject(&BackStore);
//	bDC.BitBlt(0,0,SIZE,SIZE,dc,x,y,SRCCOPY);
	
	//Copy sprite to AND bitmap (note background colour)
	CBitmap bitmapAnd;
	bitmapAnd.CreateBitmap(SIZE,SIZE,1,1,NULL);
	CDC dcAnd;
	dcAnd.CreateCompatibleDC(dc);
	dcAnd.SelectObject(&bitmapAnd);
	dcAnd.BitBlt(0,0,SIZE,SIZE,&bDC,0,angle*SIZE,SRCCOPY);

	//..and to XOR bitmap, then apply AND mask to it
	CBitmap bitmapXor;
	bitmapXor.CreateCompatibleBitmap(&bDC,SIZE,SIZE);
	CDC dcXor;
	dcXor.CreateCompatibleDC(dc);
	dcXor.SelectObject(&bitmapXor);
	dcXor.BitBlt(0,0,SIZE,SIZE,&bDC,0,angle*SIZE,SRCCOPY);
	dcXor.BitBlt(0,0,SIZE,SIZE,&dcAnd,0,0,0x220326);

	//Copy background to bitmapTemp, apply the masks and copy back
	CBitmap bitmapTemp;
	bitmapTemp.CreateCompatibleBitmap(&bDC,SIZE,SIZE);
	CDC dcTemp;
	dcTemp.CreateCompatibleDC(dc);
	dcTemp.SelectObject(&bitmapTemp);
	dcTemp.BitBlt(0,0,SIZE,SIZE,&buffDC,x,y,SRCCOPY); //background
	dcTemp.BitBlt(0,0,SIZE,SIZE,&dcAnd,0,0,SRCAND); //and mask
	dcTemp.BitBlt(0,0,SIZE,SIZE,&dcXor,0,0,SRCINVERT); //or mask
	dc->BitBlt(0,0,width,height,&buffDC,wx,wy,SRCCOPY);
	dc->BitBlt(x-wx,y-wy,SIZE,SIZE,&dcTemp,0,0,SRCCOPY);
}

void CMainWindow::OnPaint()
{
	CPaintDC dc(this);
	if(bpause)
	{
		CRect rect;
		GetClientRect(&rect);
		dc.DrawText ("Game Paused",-1,&rect,DT_SINGLELINE|DT_CENTER|DT_VCENTER);
	}
	bpaint=true;
}
void CMainWindow::pause()
{
	if(bpause=!bpause)
	{
		pThread->SuspendThread();
		Invalidate();
	}
	else
		pThread->ResumeThread();
}

UINT move(LPVOID lp)
{
	CMainWindow* pWnd= (CMainWindow*) lp;
	CRect rect;

	CDC* dc;
	int vx=0,vy=0,angle=0;
	int tmp,cx,cy,fe,ft;
	int keytimer;
	bool cangle;

	for(;;)
	{
		cangle=false;
		if(!fturn ||(keytimer++)&1)
		{
			if(kanticlock) {
				cangle=true;
				angle--;
			}
			if(kclock) {
				cangle=true;
				angle++;
			}
			angle&=0x1F;
		}
		//Limit velocity if necessary
		if(bLIMIT)
		{
			tmp=(vx*vx+vy*vy)/PREC;
			if(tmp>gLIMIT)
			{
				vx=(vx*(gLIMIT*PREC/tmp))/PREC;
				vy=(vy*(gLIMIT*PREC/tmp))/PREC;
			}
		}
		//Standard friction proprtional to velocitiy
		vx-=vx/gDRAG;
		vy-=vy/gDRAG;

		if(kaccel)
			fe=gFORCE;
		else if(kbreak)
			fe=-gFORCE/2;
		else
			fe=0;

		ft=(vy*sines.sin(angle)+vx*sines.cos(angle))/PREC;
		tmp=(fe*fe+ft*ft)/PREC;
		if(tmp>gFRICTION)
		{
			fe=(fe*(gFRICTION*PREC/tmp))/PREC;
			ft=(ft*(gFRICTION*PREC/tmp))/PREC;
			keytimer=1;
		}
		vx+=(fe*sines.sin(angle)-ft*sines.cos(angle))/PREC;
		vy-=(fe*sines.cos(angle)+ft*sines.sin(angle))/PREC;

		cx=vx/PREC;
		cy=vy/PREC;

#ifdef DEBUG
		//Bounce off the window edges
		if(x+cx<0 || x+cx>rect.right-SIZE) {
			vx=-vx;
			cx=0;
		}
		if(y+cy<0 || y+cy>rect.bottom-SIZE) {
			vy=-vy;
			cy=0;
		}
#endif

		if(cx||cy||cangle||bpaint)
		{
			dc=pWnd->GetDC();
			pWnd->GetClientRect(&rect);
			//if(bpaint)
			//	drawBackground(dc,rect.right,rect.bottom);
			//else
			//	restoreBackground(dc,x,y);
			bpaint=false;
			x+=cx;
			y+=cy;
#ifndef DEBUG
			//Test if car is on the Track
			if(level[LEVELX*((y+SIZE/2)/BACKX)+(x+SIZE/2)/BACKX]==0)
			{
				pWnd->Invalidate();
				pWnd->MessageBox("Game Over!","Micro",MB_ICONEXCLAMATION|MB_OK);
				x=y=120;
				vx=vy=angle=0;
				kanticlock=kclock=kaccel=kbreak=false;
			}
#endif
			draw(dc,rect.right,rect.bottom,x,y,angle);
			pWnd->ReleaseDC(dc);
		}
		::Sleep(40);
	}
	return 0;
}

void CMainWindow::OnKeyUp(UINT nKey,UINT,UINT)
{
	switch(nKey)
	{
	case VK_LEFT:
		kanticlock=false;
		break;
	case VK_RIGHT:
		kclock=false;
		break;
	case VK_UP:
		kaccel=false;
		break;
	case VK_DOWN:
		kbreak=false;
		break;
	default:
		break;
	}
}

void CMainWindow::OnKeyDown(UINT nKey,UINT,UINT)
{
	switch(nKey)
	{
	case VK_LEFT:
		kanticlock=true;
		break;
	case VK_RIGHT:
		kclock=true;
		break;
	case VK_UP:
		kaccel=true;
		break;
	case VK_DOWN:
		kbreak=true;
		break;
	default:
		break;
	}
}

void CMainWindow::OnClose()
{
	pThread->SuspendThread();
	delete pThread;
	CFrameWnd::OnClose();
}

//******************************************************************************************
BEGIN_MESSAGE_MAP(CSettingsDialog, CDialog)
	ON_BN_CLICKED(IDDEFAULT, OnDefaults)
	ON_COMMAND(IDC_CMAX, OnEnableSpeed)
END_MESSAGE_MAP()

void CSettingsDialog::OnDefaults()
{
	m_nDrag=DRAG;
	m_nFriction=FRICTION/PREC;
	m_nSpeed=LIMIT/PREC;
	m_nForce=FORCE/PREC;
	m_bSpeed=TRUE;
	m_bFastTurn=TRUE;
	UpdateData(FALSE);
}

void CSettingsDialog::OnEnableSpeed()
{
	(GetDlgItem(IDC_MAX))->EnableWindow(m_bEnabled);
	m_bEnabled=!m_bEnabled;
}
void CSettingsDialog::DoDataExchange(CDataExchange *pDX)
{
	CDialog::DoDataExchange(pDX);

	DDX_Check(pDX,IDC_CMAX,m_bSpeed);
	DDX_Check(pDX,IDC_CFASTTURN,m_bFastTurn);
	DDX_Text(pDX,IDC_DRAG,m_nDrag);
	DDV_MinMaxInt(pDX,m_nDrag,1,64);
	DDX_Text(pDX,IDC_MAX,m_nSpeed);
	DDV_MinMaxFloat(pDX,m_nSpeed,1,512);
	DDX_Text(pDX,IDC_FRICTION,m_nFriction);
	DDV_MinMaxFloat(pDX,m_nFriction,0,100);
	DDX_Text(pDX,IDC_FORCE,m_nForce);
	DDV_MinMaxFloat(pDX,m_nForce,0,100);
	m_bEnabled=m_bSpeed;
	OnEnableSpeed();
}

//******************************************************************************************
// DDBToDIB             - Creates a DIB from a DDB
 // bitmap               - Device dependent bitmap
 // dwCompression        - Type of compression - see BITMAPINFOHEADER
 // pPal                 - Logical palette
HANDLE DDBToDIB( CBitmap& bitmap, DWORD dwCompression, CPalette* pPal ) 
 {
	BITMAP bm;
	BITMAPINFOHEADER bi;
	LPBITMAPINFOHEADER lpbi;
	DWORD dwLen;
	HANDLE hDIB,handle;
	HDC hDC;
	HPALETTE hPal;

	ASSERT( bitmap.GetSafeHandle() );

	// The function has no arg for bitfields
	if( dwCompression == BI_BITFIELDS )
		return NULL;

	// If a palette has not been supplied use defaul palette
	hPal = (HPALETTE) pPal->GetSafeHandle();
	if (hPal==NULL)
		hPal = (HPALETTE) GetStockObject(DEFAULT_PALETTE);

	// Get bitmap information
	bitmap.GetObject(sizeof(bm),(LPSTR)&bm);

	// Initialize the bitmapinfoheader
	bi.biSize = sizeof(BITMAPINFOHEADER);
	bi.biWidth = bm.bmWidth;
	bi.biHeight = bm.bmHeight;
	bi.biPlanes = 1;
	bi.biBitCount = bm.bmPlanes * bm.bmBitsPixel;
	bi.biCompression = dwCompression;
	bi.biSizeImage = bi.biXPelsPerMeter = bi.biYPelsPerMeter = bi.biClrUsed = bi.biClrImportant = 0;

	// Compute the size of the  infoheader and the color table
//	int nColors = (1 << bi.biBitCount);
//	if( nColors > 256 ) 
//		nColors = 0;
	int nColors = 0;
	if( bi.biBitCount <= 8)
		nColors = (1 << bi.biBitCount);
 

	dwLen  = bi.biSize + nColors * sizeof(RGBQUAD);

	// We need a device context to get the DIB from
	hDC = GetDC(NULL);
	hPal = SelectPalette(hDC,hPal,FALSE);
	RealizePalette(hDC);

	// Allocate enough memory to hold bitmapinfoheader and color table
	hDIB = GlobalAlloc(GMEM_FIXED,dwLen);

	if (!hDIB){
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	lpbi = (LPBITMAPINFOHEADER)hDIB;

	*lpbi = bi;

	// Call GetDIBits with a NULL lpBits param, so the device driver 
	// will calculate the biSizeImage field 
	GetDIBits(hDC, (HBITMAP)bitmap.GetSafeHandle(), 0L, (DWORD)bi.biHeight,
		(LPBYTE)NULL, (LPBITMAPINFO)lpbi, (DWORD)DIB_RGB_COLORS);

	bi = *lpbi;

	// If the driver did not fill in the biSizeImage field, then compute it
	// Each scan line of the image is aligned on a DWORD (32bit) boundary
	if (bi.biSizeImage == 0) {
		bi.biSizeImage = ((((bi.biWidth * bi.biBitCount) + 31) & ~31) / 8) * bi.biHeight;

		// If a compression scheme is used the result may infact be larger
		// Increase the size to account for this.
		if (dwCompression != BI_RGB)
			bi.biSizeImage = (bi.biSizeImage * 3) / 2;
	}

	// Realloc the buffer so that it can hold all the bits
	dwLen += bi.biSizeImage;
	if (handle = GlobalReAlloc(hDIB, dwLen, GMEM_MOVEABLE))
		hDIB = handle;
	else {
		GlobalFree(hDIB);

		// Reselect the original palette
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	// Get the bitmap bits
	lpbi = (LPBITMAPINFOHEADER)hDIB;

	// FINALLY get the DIB
	BOOL bGotBits = GetDIBits( hDC, (HBITMAP)bitmap.GetSafeHandle(),0L,(DWORD)bi.biHeight,
		(LPBYTE)lpbi+(bi.biSize + nColors * sizeof(RGBQUAD)),(LPBITMAPINFO)lpbi,(DWORD)DIB_RGB_COLORS);

	if(!bGotBits)
	{
		GlobalFree(hDIB);
                 
		SelectPalette(hDC,hPal,FALSE);
		ReleaseDC(NULL,hDC);
		return NULL;
	}

	SelectPalette(hDC,hPal,FALSE);
	ReleaseDC(NULL,hDC);
	return hDIB;
 }


BOOL WriteDIB(LPSTR szFile, HANDLE hDIB)
{
	BITMAPFILEHEADER hdr;
	BITMAPINFOHEADER *lpbi;

	if(!hDIB) return FALSE;
	CFile file;
	if(!file.Open(szFile,CFile::modeWrite|CFile::modeCreate)) return FALSE;

	lpbi=(LPBITMAPINFOHEADER)GlobalLock(hDIB);
	int nColors = 0;
	if( lpbi->biBitCount <= 8)
		nColors = (1 << lpbi->biBitCount);
	//int nColors=1<<lpbi->biBitCount;

	hdr.bfType=((WORD)('M'<<8)|'B');
	hdr.bfSize=GlobalSize(hDIB)+sizeof(hdr);
	hdr.bfReserved1=hdr.bfReserved2=0;
	hdr.bfOffBits=(DWORD)(sizeof(hdr)+lpbi->biSize+nColors*sizeof(RGBQUAD));

	file.Write(&hdr,sizeof(hdr));
	file.Write(lpbi,GlobalSize(hDIB));

	GlobalUnlock(hDIB);
	return TRUE;
}

/*

#define FRICTION 0x600
		if(kaccel)
		{
			vx+=sines.sin(angle);
			vy-=sines.cos(angle);
		}
		else if(kbreak)
		{
			vx-=sines.sin(angle)/2;
			vy+=sines.cos(angle)/2;
		}

		tmp=(vy*sines.sin(angle)+vx*sines.cos(angle))/PREC;
		if(tmp>FRICTION)
			tmp=FRICTION;
		else if(tmp<-FRICTION)
			tmp=-FRICTION;
		vx-=tmp*sines.cos(angle)/PREC;
		vy-=tmp*sines.sin(angle)/PREC;
*/
