;************************* TILE.H *************************
; Tile store.
; Code may not be able to cope with sizes other than 32*32
; Needs GREY to be defined before included.
;**********************************************************
	ifnd	GREY
	end
	endif
;**********************************************************

TILE	macro	line1,line1_gray,line2,line2_gray
	_TILE.\0	\1,\2
	_TILE.\0	\3,\4
	endm
_TILE	macro	line,line_gray
	IFGT	GREY	;swap it around, so it looks better
	dc.\0	\1
	ENDIF
	dc.\0	\2
	endm
TSIZE	equ	32	*
TXBYTES	equ	TSIZE/8
TLBYTES	equ	TXBYTES*(1+GREY)
TBYTES	equ	TSIZE*TLBYTES	; 2^7/2^8

TSHIFT	equ	7+GREY	*
TYSHIFT	equ	2+GREY	*
TGET	macro	dest
	lsl.\0	#TSHIFT,\1
	endm
TGETY	macro	dest
	lsl.\0	#TYSHIFT,\1
	endm
TMOVE	macro	source,dest
	ifeq	TXBYTES-1
	move.b	\1,\2
	endif
	ifeq	TXBYTES-2
	move.w	\1,\2
	endif
	ifeq	TXBYTES-4
	move.l	\1,\2
	endif
	endm
;**********************************************************
